  implicit none
  
  ! Includes ncessaires  l'utilisation des librairies HDF

  include 'icadffunc.f90'
  include 'hdf.f90'
  include 'netcdf.f90'

  integer, parameter :: &
       UNCLBRTD = -1, &
       DECLBRTD =  0, &
       CALIBRTD =  1

  character(len=15), dimension(-1:1) :: &
       clbrstat = (/'SDS non calibr', 'SDS dcalibr  ', 'SDS calibr    '/)

  ! Dclaration du nouveau type de donne hdf_att

  type hdf_data

     integer                                    :: &
          type,                        & ! Type des donnes
          datasize,                    & ! Taille en octets du type des donnes
          size,                        & ! Taille en octets des donnes
          nval,                        & ! Nombre de valeurs des donnes
          rank,                        & ! Nombre de dimensions des donnes
          dimsize(MAXNCDIM),           & ! Valeurs des dimensions des donnes
          utype,                       & ! Type des donnes dcalibres
          calbrtd                        ! Statut de calibration des donnes

     real(kind=8) &
          calibr(4)                      ! Coefficients ventuels de calibration des donnes

     character,       dimension(:), allocatable :: &
          c1values                       ! Valeurs des donnes

     integer(kind=1), dimension(:), allocatable :: &
          i1values                       ! Valeurs des donnes

     integer(kind=2), dimension(:), allocatable :: &
          i2values                       ! Valeurs des donnes

     integer(kind=4), dimension(:), allocatable :: &
          i4values                       ! Valeurs des donnes

! En prvision...
!     integer(kind=8), dimension(:), allocatable :: &
!          i8values                       ! Valeurs des donnes

     real   (kind=4), dimension(:), allocatable :: &
          r4values                       ! Valeurs des donnes

     real   (kind=8), dimension(:), allocatable :: &
          r8values                       ! Valeurs des donnes

  end type hdf_data

  ! Dclaration du nouveau type de donne hdf_att

  type hdf_att

     character (len=MAXNCNAM)                   :: &
          name                           ! Nom de l'attribut

     type(hdf_data)                             :: &
          data

  end type hdf_att

  ! Dclaration du nouveau type de donne sds_struct

  type hdf_sds

     character (len=MAXNCNAM)                   :: &
          name                           ! Nom du SDS

     integer                                    :: &
          nattr                          ! Nombre d'attributs du SDS                     

     type(hdf_data)                             :: &
          data                           ! Donnes du SDS

     type(hdf_att), dimension(:), allocatable   :: &
          attr                           ! Attributs du SDS

  end type hdf_sds
